Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## jason.stdlib
Class min

    java.lang.Object
      jason.asSemantics.DefaultInternalAction
          jason.stdlib.min

All Implemented Interfaces:
  InternalAction, java.io.Serializable

Direct Known Subclasses:
  max

    public class min

extends DefaultInternalAction

Internal action: `.min`.

Description: gets the minimum value of a list of terms, using the "natural" order of terms. Between different types of terms, the following order is used:
numbers < atoms < structures < lists

Parameters:

- + list (list): the list where to find the minimal term.
- +/- minimal (term).

Examples:

- `.min([c,a,b],X)`: `X` unifies with `a`.
- `.min([b,c,10,g,f(10),[3,4],5,[3,10],f(4)],X)`: `X` unifies with `5`.
- `.min([3,2,5],2)`: true.
- `.min([3,2,5],5)`: false.
- `.min([],X)`: false.

See Also:
  `concat`, `delete`, `length`, `member`, `nth`, `sort`, `max`, `reverse`, `difference`, `intersection`, `union`, Serialized Form

Constructor Summary
`min()`

Method Summary
`protected void` | `checkArguments(Term[] args)`
`protected boolean` | `compare(Term a, Term t)`
`static InternalAction` | `create()`
`java.lang.Object` | `execute(TransitionSystem ts, Unifier un, Term[] args)` Executes the internal action.
`int` | `getMaxArgs()`
`int` | `getMinArgs()`

Methods inherited from class jason.asSemantics.DefaultInternalAction
`canBeUsedInContext, prepareArguments, suspendIntention`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### min

    public min()

Method Detail

### create

    public static InternalAction create()

### getMinArgs

    public int getMinArgs()

  Overrides:
    `getMinArgs` in class `DefaultInternalAction`

### getMaxArgs

    public int getMaxArgs()

  Overrides:
    `getMaxArgs` in class `DefaultInternalAction`

### checkArguments

    protected void checkArguments(Term[] args)
                           throws JasonException

  Overrides:
    `checkArguments` in class `DefaultInternalAction`
  Throws:
    `JasonException`

### execute

    public java.lang.Object execute(TransitionSystem ts,
                                    Unifier un,
                                    Term[] args)
                             throws java.lang.Exception

  Description copied from interface: `InternalAction`
  Executes the internal action. It should return a Boolean or an Iterator. A true boolean return means that the IA was successfully executed. An Iterator result means that there is more than one answer for this IA (e.g. see member internal action).

  Specified by:
    `execute` in interface `InternalAction`
  Overrides:
    `execute` in class `DefaultInternalAction`
  Throws:
    `java.lang.Exception`

### compare

    protected boolean compare(Term a,
                              Term t)

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD